<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: io/readpatran.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_7dc76e12c3f74bb85b7effb3b7dc07e4.html">io</a>
  </div>
</div>
<div class="contents">
<h1>readpatran.c</h1><a href="readpatran_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: readpatran.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">magpario.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">/* Reads in the grid data from a Patran Neutral file */</span>
<a name="l00030"></a>00030 
<a name="l00031"></a><a class="code" href="readpatran_8c.html#a4e53aaaa9226ca0805f1f006e8bda38a">00031</a> <span class="keywordtype">int</span> <a class="code" href="magpario_8h.html#a4e53aaaa9226ca0805f1f006e8bda38a">ReadPatran</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033   <span class="keywordtype">int</span>          i;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   <span class="keywordtype">char</span>         msg[256],fmesh[256];
<a name="l00036"></a>00036   FILE         *fd;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="keywordtype">int</span>          a1,a2,a3,a4;
<a name="l00039"></a>00039   <span class="keywordtype">int</span>          it, id, iv, kc, n1, n2, n3, n4, n5;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="keywordtype">int</span> rank,size;
<a name="l00045"></a>00045   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00046"></a>00046   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="keywordflow">if</span> (rank) {
<a name="l00049"></a>00049     gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>=0;
<a name="l00050"></a>00050     gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>=0;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00053"></a>00053   }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   <span class="comment">/* TODO: read filename directly from option */</span>
<a name="l00056"></a>00056   ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s%s&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,<span class="stringliteral">&quot;.out&quot;</span>);CHKERRQ(ierr);
<a name="l00057"></a>00057   ierr = PetscFOpen(PETSC_COMM_WORLD,fmesh,<span class="stringliteral">&quot;r&quot;</span>,&amp;fd);CHKERRQ(ierr);
<a name="l00058"></a>00058   <span class="keywordflow">if</span> (!rank &amp;&amp; !fd) {
<a name="l00059"></a>00059     SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,fmesh);
<a name="l00060"></a>00060   }
<a name="l00061"></a>00061   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening file %s\n&quot;</span>,fmesh);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">/* read in number of vertices */</span>
<a name="l00064"></a>00064   fscanf(fd,<span class="stringliteral">&quot;%i %i %i %i %i %i %i %i %i\n&quot;</span>,
<a name="l00065"></a>00065     &amp;it,&amp;<span class="keywordtype">id</span>,&amp;iv,&amp;kc,&amp;n1,&amp;n2,&amp;n3,&amp;n4,&amp;n5
<a name="l00066"></a>00066   );
<a name="l00067"></a>00067   assert(it==25); <span class="comment">/* packet type 25: title card */</span>
<a name="l00068"></a>00068   assert(<span class="keywordtype">id</span>==0);
<a name="l00069"></a>00069   assert(iv==0);
<a name="l00070"></a>00070   assert(kc==1);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   fgets(msg,256,fd);
<a name="l00073"></a>00073   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Title: %s\n&quot;</span>,msg);
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   fscanf(fd,<span class="stringliteral">&quot;%i %i %i %i %i %i %i %i %i\n&quot;</span>,
<a name="l00076"></a>00076     &amp;it,&amp;<span class="keywordtype">id</span>,&amp;iv,&amp;kc,&amp;n1,&amp;n2,&amp;n3,&amp;n4,&amp;n5
<a name="l00077"></a>00077   );
<a name="l00078"></a>00078   assert(it==26); <span class="comment">/* packet type 26: summary data */</span>
<a name="l00079"></a>00079   assert(<span class="keywordtype">id</span>==0);
<a name="l00080"></a>00080   assert(iv==0);
<a name="l00081"></a>00081   assert(kc==1);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>=n1;
<a name="l00084"></a>00084   gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>=gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;
<a name="l00085"></a>00085   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of grid vertices: %i\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>);
<a name="l00086"></a>00086   gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>=n2;
<a name="l00087"></a>00087   gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>=gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;
<a name="l00088"></a>00088   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of grid elements: %i\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>);
<a name="l00089"></a>00089   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of materials:     %i\n&quot;</span>,n3);
<a name="l00090"></a>00090   gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>=n4;
<a name="l00091"></a>00091   assert(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>&gt;0);
<a name="l00092"></a>00092   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of element prop.: %i\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>);
<a name="l00093"></a>00093   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of coord. frames: %i\n&quot;</span>,n5);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   fgets(msg,256,fd);
<a name="l00096"></a>00096   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Neutral file creation date, Patran Version:\n%s\n&quot;</span>,msg);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="comment">/* *************************************************************************</span>
<a name="l00099"></a>00099 <span class="comment">     Read in all vertices</span>
<a name="l00100"></a>00100 <span class="comment">  */</span>
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>);CHKERRQ(ierr);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">/* read data of all vertices */</span>
<a name="l00105"></a>00105   <span class="keywordflow">for</span> (i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00106"></a>00106     fscanf(fd,<span class="stringliteral">&quot;%i %i %i %i %i %i %i %i %i\n&quot;</span>,
<a name="l00107"></a>00107       &amp;it,&amp;<span class="keywordtype">id</span>,&amp;iv,&amp;kc,&amp;n1,&amp;n2,&amp;n3,&amp;n4,&amp;n5
<a name="l00108"></a>00108     );
<a name="l00109"></a>00109     assert(it==1); <span class="comment">/* packet type 01: node data */</span>
<a name="l00110"></a>00110     assert(iv==0);
<a name="l00111"></a>00111     assert(kc==2);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113     <span class="comment">/* assert ascending ordering without holes */</span>
<a name="l00114"></a>00114     assert(<span class="keywordtype">id</span>-1==i);
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>    fscanf(fd,<span class="stringliteral">&quot;%f %f %f\n&quot;</span>,
<a name="l00118"></a>00118 #<span class="keywordflow">else</span>
<a name="l00119"></a>00119     fscanf(fd,<span class="stringliteral">&quot;%lf %lf %lf\n&quot;</span>,
<a name="l00120"></a>00120 #endif
<a name="l00121"></a>00121       gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0,
<a name="l00122"></a>00122       gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1,
<a name="l00123"></a>00123       gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2
<a name="l00124"></a>00124     );
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     fgets(msg,256,fd);
<a name="l00127"></a>00127   }
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="comment">/* *************************************************************************</span>
<a name="l00130"></a>00130 <span class="comment">     Read in all elements</span>
<a name="l00131"></a>00131 <span class="comment">  */</span>
<a name="l00132"></a>00132   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>);CHKERRQ(ierr);
<a name="l00133"></a>00133   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>);CHKERRQ(ierr);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="keywordflow">for</span> (i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>; i++) {
<a name="l00136"></a>00136     fscanf(fd,<span class="stringliteral">&quot;%i %i %i %i %i %i %i %i %i\n&quot;</span>,
<a name="l00137"></a>00137       &amp;it,&amp;<span class="keywordtype">id</span>,&amp;iv,&amp;kc,&amp;n1,&amp;n2,&amp;n3,&amp;n4,&amp;n5
<a name="l00138"></a>00138     );
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     assert(it==2); <span class="comment">/* packet type 02: element data */</span>
<a name="l00141"></a>00141     assert(kc==2);
<a name="l00142"></a>00142     assert(n1==0);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     <span class="comment">/* assume tet elements */</span>
<a name="l00145"></a>00145     assert(iv==5);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147     <span class="comment">/* assert ascending ordering without holes */</span>
<a name="l00148"></a>00148 
<a name="l00149"></a>00149     <span class="comment">/* does not work due to unknown offset in Patran&#39;s element numbers</span>
<a name="l00150"></a>00150 <span class="comment">     * and does not really matter anyway (element numbering not interesting)</span>
<a name="l00151"></a>00151 <span class="comment"></span>
<a name="l00152"></a>00152 <span class="comment">    assert(t_cnt==id-2);</span>
<a name="l00153"></a>00153 <span class="comment">    t_cnt=id-1;</span>
<a name="l00154"></a>00154 <span class="comment">    */</span>
<a name="l00155"></a>00155 
<a name="l00156"></a>00156     fscanf(fd,<span class="stringliteral">&quot;%i %i %i %i&quot;</span>,&amp;a1,&amp;a2,&amp;a3,&amp;a4); <span class="comment">/* a3: property id */</span>
<a name="l00157"></a>00157     assert(a1==<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>); <span class="comment">/* number of nodes per element */</span>
<a name="l00158"></a>00158 
<a name="l00159"></a>00159     <span class="comment">/* internal property ids start with 0 !!! */</span>
<a name="l00160"></a>00160     gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]=--a3;
<a name="l00161"></a>00161     assert(gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]&gt;=0);
<a name="l00162"></a>00162     assert(gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>);
<a name="l00163"></a>00163 
<a name="l00164"></a>00164     fgets(msg,256,fd);
<a name="l00165"></a>00165     fscanf(fd,<span class="stringliteral">&quot;%i %i %i %i\n&quot;</span>,
<a name="l00166"></a>00166       gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>+i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+0,
<a name="l00167"></a>00167       gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>+i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+1,
<a name="l00168"></a>00168       gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>+i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+2,
<a name="l00169"></a>00169       gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>+i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+3
<a name="l00170"></a>00170     );
<a name="l00171"></a>00171     gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+0]--;
<a name="l00172"></a>00172     gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+1]--;
<a name="l00173"></a>00173     gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+2]--;
<a name="l00174"></a>00174     gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+3]--;
<a name="l00175"></a>00175   }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   ierr = PetscFClose(PETSC_COMM_WORLD,fd);CHKERRQ(ierr);
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00181"></a>00181 }
<a name="l00182"></a>00182 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

